.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib

;***************************************************************************************************

getRandomSeed proto

nrandom proto base:DWORD

;***************************************************************************************************

.const
AppTitle    db "Random Seed",0

seeds       dd seed01,seed02,seed03,seed04,seed05,seed06,seed07,seed08,seed09,seed10,seed11,0
seed01      db "Acorn",0
seed02      db "Apple",0
seed03      db "Cherry",0
seed04      db "Dandelion",0
seed05      db "Hazelnut",0
seed06      db "Mustard",0
seed07      db "Orange",0
seed08      db "Peach",0
seed09      db "Plum",0
seed10      db "Sunflower",0
seed11      db "Walnut",0
NUM_SEEDS equ 11

.data?
seed        DWORD   ?

.code
start:
    rdtsc
    mov seed,eax

    invoke getRandomSeed
    invoke MessageBox, NULL,eax,ADDR AppTitle,MB_OK or MB_ICONINFORMATION

    invoke ExitProcess, NULL

;***************************************************************************************************

ALIGN 4
getRandomSeed proc
    invoke nrandom, NUM_SEEDS
    lea edx,[seeds+4*eax]
    mov eax,[edx]
    ret
getRandomSeed endp

;***************************************************************************************************

ALIGN 4
nrandom proc base:DWORD
    mov eax,seed
    xor edx,edx
    mov ecx,127773
    div ecx
    mov ecx,eax
    mov eax,16807
    mul edx
    mov edx,ecx
    mov ecx,eax
    mov eax,2836
    mul edx
    sub ecx,eax
    xor edx,edx
    mov eax,ecx
    mov seed,ecx
    div base
    mov eax,edx
    ret
nrandom endp

;***************************************************************************************************

end start
